	.module main.c
	.area data(ram, con, rel)
_Donnee::
	.blkb 2
	.area idata
	.byte 170,'U
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e Donnee _Donnee A[2:2]c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
_main::
	.dbline -1
	.dbline 14
; //----------------------------------------------------------------------------
; // C main line			// Adresse I2C 0x40
; //----------------------------------------------------------------------------
; 
; #include <m8c.h>        // part specific constants and macros
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; 					
; int i;
; int valdep,valfin,val;
; BYTE    Donnee[2]={0xAA,0x55};  
; BYTE    status,fin;
; 
; void main()
; {
	.dbline 15
; 	Timer8_1_EnableInt();
	push X
	xcall _Timer8_1_EnableInt
	pop X
	.dbline 16
; 	M8C_EnableGInt;
		or  F, 01h

	.dbline 17
; 	LCD_1_Start();
	push X
	xcall _LCD_1_Start
	.dbline 18
; 	LCD_1_PrCString("Distance obst. :");
	mov A,>L2
	push A
	mov A,<L2
	mov X,A
	pop A
	xcall _LCD_1_PrCString
	.dbline 19
; 	DigInv_1_Start();								
	xcall _DigInv_1_Start
	.dbline 20
; 	PGA_1_Start(PGA_1_HIGHPOWER);
	mov A,3
	xcall _PGA_1_Start
	.dbline 21
; 	PGA_2_Start(PGA_2_HIGHPOWER);
	mov A,3
	xcall _PGA_2_Start
	.dbline 22
; 	BPF2_1_Start(BPF2_1_HIGHPOWER);
	mov A,3
	xcall _BPF2_1_Start
	.dbline 23
; 	CMPPRG_1_Start(CMPPRG_1_HIGHPOWER);
	mov A,3
	xcall _CMPPRG_1_Start
	.dbline 24
; 	I2CHW_1_Start();  
	xcall _I2CHW_1_Start
	.dbline 25
;     I2CHW_1_EnableSlave();
	xcall _I2CHW_1_EnableSlave
	.dbline 26
;     I2CHW_1_InitRamRead(Donnee,2);  
	mov A,2
	push A
	mov A,>_Donnee
	push A
	mov A,<_Donnee
	push A
	xcall _I2CHW_1_InitRamRead
	add SP,-3
	.dbline 27
;     I2CHW_1_InitWrite(Donnee,0);	// pas d'criture
	mov A,0
	push A
	mov A,>_Donnee
	push A
	mov A,<_Donnee
	push A
	xcall _I2CHW_1_InitWrite
	add SP,-3
	.dbline 28
;     I2CHW_1_EnableInt(); 
	xcall _I2CHW_1_EnableInt
	pop X
	.dbline 29
; 	fin=0;
	mov [_fin],0
	xjmp L4
L3:
	.dbline 32
; 	
; 	while (1)
; 	{
	.dbline 33
; 		status = I2CHW_1_bReadI2CStatus();  
	push X
	xcall _I2CHW_1_bReadI2CStatus
	pop X
	mov [_status],A
	.dbline 35
;         // Attente que les donnes soient lues par le matre
;         if( (status & I2CHW_RD_COMPLETE )==I2CHW_RD_COMPLETE)  
	mov A,[_status]
	and A,4
	cmp A,4
	jnz L6
	.dbline 36
;         {	I2CHW_1_ClrRdStatus();  
	.dbline 36
	push X
	xcall _I2CHW_1_ClrRdStatus
	.dbline 38
; 	        // Reinitialise le pointeur pour prochaine lecture
; 	        I2CHW_1_InitRamRead(Donnee,2);
	mov A,2
	push A
	mov A,>_Donnee
	push A
	mov A,<_Donnee
	push A
	xcall _I2CHW_1_InitRamRead
	add SP,-3
	.dbline 40
; 	        // lance une nouvelle mesure 
;         	Timer8_1_Start();
	xcall _Timer8_1_Start
	.dbline 41
;     		valdep=Counter16_1_wReadCounter();
	xcall _Counter16_1_wReadCounter
	mov [__r0],X
	pop X
	mov [_valdep+1],A
	mov [_valdep],[__r0]
	.dbline 42
;     		Counter16_1_Start();
	push X
	xcall _Counter16_1_Start
	pop X
	.dbline 43
;     		fin=0;
	mov [_fin],0
	xjmp L9
L8:
	.dbline 45
;     		while(fin==0)
;     		{
	.dbline 46
;     			val=valdep-Counter16_1_wReadCounter();
	push X
	xcall _Counter16_1_wReadCounter
	mov [__r1],A
	mov [__r0],X
	pop X
	mov A,[_valdep+1]
	sub A,[__r1]
	mov [__r1],A
	mov A,[_valdep]
	sbb A,[__r0]
	mov [_val+1],[__r1]
	mov [_val],A
	.dbline 47
;     			if (val>30000) 
	mov A,48
	sub A,[_val+1]
	mov A,[_val]
	xor A,-128
	mov [__rX],A
	mov A,(117 ^ 0x80)
	sbb A,[__rX]
	jnc L11
X1:
	.dbline 48
;     			{
	.dbline 49
;     				fin=1;	// obstacle hors porte (>5m)
	mov [_fin],1
	.dbline 50
;     				Donnee[1]=0xFF;
	mov [_Donnee+1],-1
	.dbline 51
;     				Donnee[0]=0xFF;
	mov [_Donnee],-1
	.dbline 52
;     			}
	xjmp L12
L11:
	.dbline 54
;     			else
;     			{
	.dbline 55
;     				if(val>3500) PGA_2_SetGain(PGA_2_G16_0);
	mov A,-84
	sub A,[_val+1]
	mov A,[_val]
	xor A,-128
	mov [__rX],A
	mov A,(13 ^ 0x80)
	sbb A,[__rX]
	jnc L14
X2:
	.dbline 55
	push X
	mov A,8
	xcall _PGA_2_SetGain
	pop X
	xjmp L15
L14:
	.dbline 57
;     				else 
;     				{	if(val>2000) PGA_2_SetGain(PGA_2_G8_00);
	.dbline 57
	mov A,-48
	sub A,[_val+1]
	mov A,[_val]
	xor A,-128
	mov [__rX],A
	mov A,(7 ^ 0x80)
	sbb A,[__rX]
	jnc L16
X3:
	.dbline 57
	push X
	mov A,24
	xcall _PGA_2_SetGain
	pop X
	xjmp L17
L16:
	.dbline 58
;     					else PGA_2_SetGain(PGA_2_G4_00);
	push X
	mov A,56
	xcall _PGA_2_SetGain
	pop X
L17:
	.dbline 59
;     				}	
L15:
	.dbline 60
;     			}
L12:
	.dbline 61
L9:
	.dbline 44
	cmp [_fin],0
	jz L8
	.dbline 62
;     		}
;     	}							
L6:
	.dbline 63
L4:
	.dbline 31
	xjmp L3
X0:
	.dbline -2
	.dbline 64
;     }
; }
L1:
	.dbline 0 ; func end
	jmp .
	.dbend
	.dbfunc e timer8_isr _timer8_isr fV
_timer8_isr::
	.dbline -1
	push A
	mov A,REG[0xd0]
	push A
	mov A,REG[0xd3]
	push A
	mov A,REG[0xd4]
	push A
	mov A,REG[0xd5]
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,[__r8]
	push A
	mov A,[__r9]
	push A
	mov A,[__r10]
	push A
	mov A,[__r11]
	push A
	mov A,[__rX]
	push A
	mov A,[__rY]
	push A
	mov A,[__rZ]
	push A
	.dbline 68
	.dbline 69
	inc [_i+1]
	adc [_i],0
	.dbline 70
	cmp [_i],0
	jnz L19
	cmp [_i+1],8
	jnz L19
X4:
	.dbline 71
	.dbline 71
	push X
	xcall _Timer8_1_Stop
	pop X
	.dbline 72
	mov [_i+1],0
	mov [_i],0
	.dbline 73
	mov REG[0xda],-9
	.dbline 74
	or REG[0xe0],8
	.dbline 75
L19:
	.dbline -2
	.dbline 76
; 
; #pragma interrupt_handler timer8_isr
; void timer8_isr()
; {
; 	i++;
; 	if (i==8) 
; 	{	Timer8_1_Stop();
; 		i=0;
; 		M8C_ClearIntFlag(INT_CLR0,INT_MSK0_ACOLUMN_2);
;     	M8C_EnableIntMask(INT_MSK0, INT_MSK0_ACOLUMN_2);	//autorisation inter sur front montant 
; 	}													// "comparator 2" analogique
; }
L18:
	pop A
	mov [__rZ],A
	pop A
	mov [__rY],A
	pop A
	mov [__rX],A
	pop A
	mov [__r11],A
	pop A
	mov [__r10],A
	pop A
	mov [__r9],A
	pop A
	mov [__r8],A
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	mov [__r4],A
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	pop A
	mov REG[213],A
	pop A
	mov REG[212],A
	pop A
	mov REG[211],A
	pop A
	mov REG[208],A
	pop A
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e analog2_isr _analog2_isr fV
_analog2_isr::
	.dbline -1
	push A
	mov A,REG[0xd0]
	push A
	mov A,REG[0xd3]
	push A
	mov A,REG[0xd4]
	push A
	mov A,REG[0xd5]
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,[__r8]
	push A
	mov A,[__r9]
	push A
	mov A,[__r10]
	push A
	mov A,[__r11]
	push A
	mov A,[__rX]
	push A
	mov A,[__rY]
	push A
	mov A,[__rZ]
	push A
	.dbline 80
; 
; #pragma interrupt_handler analog2_isr	// ljmp _detection_isr dans boot.tpl sur inter analog 2
; void analog2_isr()
; {
	.dbline 81
; 	Counter16_1_Stop();
	push X
	xcall _Counter16_1_Stop
	pop X
	.dbline 82
; 	M8C_DisableIntMask(INT_MSK0, INT_MSK0_ACOLUMN_2);
	and REG[0xe0],-9
	.dbline 83
; 	valfin=Counter16_1_wReadCounter();
	push X
	xcall _Counter16_1_wReadCounter
	mov [__r0],X
	pop X
	mov [_valfin+1],A
	mov [_valfin],[__r0]
	.dbline 84
; 	fin=1;
	mov [_fin],1
	.dbline 85
; 	val=valdep-valfin;	//le compteur decompte ! 
	mov A,[_valdep+1]
	sub A,[_valfin+1]
	mov [_val+1],A
	mov A,[_valdep]
	sbb A,[_valfin]
	mov [_val],A
	.dbline 86
; 	val=val/119;		// distance en cm avec horloge 2MHz
	mov A,0
	push A
	mov A,119
	push A
	mov A,[_val]
	push A
	mov A,[_val+1]
	push A
	xcall __divmod_16X16_16
	pop A
	mov [_val+1],A
	pop A
	mov [_val],A
	add SP,-2
	.dbline 87
; 	Donnee[1]=(val & 0x00FF);
	mov A,[_val+1]
	mov [_Donnee+1],A
	.dbline 88
;     Donnee[0]=(val>>8); 
	mov [__r1],[_val]
	tst [__r1],-128
	jnz X5
	mov [__r0],0
	jmp X6
X5:
X6:
	mov [_Donnee],[__r1]
	.dbline 89
; 	LCD_1_Position(1,5);
	push X
	mov X,5
	mov A,1
	xcall _LCD_1_Position
	.dbline 90
; 	LCD_1_PrHexInt(val);
	mov X,[_val]
	mov A,[_val+1]
	xcall _LCD_1_PrHexInt
	.dbline 91
; 	LCD_1_PrCString("cm");
	mov A,>L23
	push A
	mov A,<L23
	mov X,A
	pop A
	xcall _LCD_1_PrCString
	pop X
	.dbline -2
	.dbline 92
; }
L21:
	pop A
	mov [__rZ],A
	pop A
	mov [__rY],A
	pop A
	mov [__rX],A
	pop A
	mov [__r11],A
	pop A
	mov [__r10],A
	pop A
	mov [__r9],A
	pop A
	mov [__r8],A
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	mov [__r4],A
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	pop A
	mov REG[213],A
	pop A
	mov REG[212],A
	pop A
	mov REG[211],A
	pop A
	mov REG[208],A
	pop A
	.dbline 0 ; func end
	reti
	.dbend
	.area bss(ram, con, rel)
	.dbfile ./main.c
_fin::
	.blkb 1
	.dbsym e fin _fin c
_status::
	.blkb 1
	.dbsym e status _status c
_val::
	.blkb 2
	.dbsym e val _val I
_valfin::
	.blkb 2
	.dbsym e valfin _valfin I
_valdep::
	.blkb 2
	.dbsym e valdep _valdep I
_i::
	.blkb 2
	.dbsym e i _i I
	.area lit(rom, con, rel)
L23:
	.byte 'c,'m,0
L2:
	.byte 'D,'i,'s,'t,'a,'n,'c,'e,32,'o,'b,'s,'t,46,32,58
	.byte 0
